CSIT-806 Container Orchestration in CSIT - Low Level Design
[csit.git] / bootstrap-hc2vpp-integration.sh
1 #!/bin/bash
2 # Copyright (c) 2016 Cisco and/or its affiliates.
3 # Licensed under the Apache License, Version 2.0 (the "License");
4 # you may not use this file except in compliance with the License.
5 # You may obtain a copy of the License at:
6 #
7 #     http://www.apache.org/licenses/LICENSE-2.0
8 #
9 # Unless required by applicable law or agreed to in writing, software
10 # distributed under the License is distributed on an "AS IS" BASIS,
11 # WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
12 # See the License for the specific language governing permissions and
13 # limitations under the License.
14
15 set -x
16
17 cat /etc/hostname
18 cat /etc/hosts
19
20 export DEBIAN_FRONTEND=noninteractive
21 sudo apt-get -y update
22 sudo apt-get -y install libpython2.7-dev python-virtualenv
23
24 VIRL_SERVERS=("10.30.51.28" "10.30.51.29" "10.30.51.30")
25 VIRL_SERVER=""
26
27 VIRL_USERNAME=jenkins-in
28 VIRL_PKEY=priv_key
29 VIRL_SERVER_STATUS_FILE="status"
30 VIRL_SERVER_EXPECTED_STATUS="PRODUCTION"
31
32 ARCHIVE_ARTIFACTS=(log.html output.xml report.html honeycomb.log)
33
34 STREAM=$1
35 OS=$2
36
37 if [ "${OS}" == "ubuntu1604" ]; then
38     VIRL_TOPOLOGY=double-ring-nested.xenial
39     VIRL_RELEASE=csit-ubuntu-16.04.1_2017-02-23_1.8
40 elif [ "${OS}" == "centos7" ]; then
41     VIRL_TOPOLOGY=double-ring-nested.centos7
42     VIRL_RELEASE=csit-centos-7.3-1611_2017-02-23_1.4
43 fi
44
45 SSH_OPTIONS="-i ${VIRL_PKEY} -o StrictHostKeyChecking=no -o UserKnownHostsFile=/dev/null -o BatchMode=yes -o LogLevel=error"
46
47 function ssh_do() {
48     echo
49     echo "### "  ssh $@
50     ssh ${SSH_OPTIONS} $@
51 }
52
53 rm -f ${VIRL_PKEY}
54 cat > ${VIRL_PKEY} <<EOF
55 -----BEGIN RSA PRIVATE KEY-----
56 MIIEpQIBAAKCAQEA+IHXq87GcqMR1C47rzx6Cbip5Ghq8pKrbqKrP5Nf41HcYrT6
57 GOXl9nFWKsMOzIlIn+8y7Il27eZh7csQGApbg8QLiHMtcYEmWNzKZpkqg4nuAPxX
58 VXwlKgnKX902SrET9Gp9TDayiHtCRWVfrlPPPSA0UEXW6BjLN/uHJ+W/Xzrrab+9
59 asBVa05vT2W6n0KJ66zfCaeDM912mQ6SttscAwFoWDmdHlegiVqrlIG2ABxOvxxz
60 L3dM3iSmlmQlzv9bThjo+nI4KFYh6m5wrZmAo5r/4q9CIJc21HVnTqkGOWJIZz6J
61 73lePJVSq5gYqaoGw3swFEA/MDkOx7baWKSoLQIDAQABAoIBAQCNBeolNp+JWJ76
62 gQ4fwLsknyXSV6sxYyhkDW4PEwwcTU06uqce0AAzXVffxne0fMe48x47+zqBgPbb
63 4huM+Pu8B9nfojUMr5TaYtl9Zbgpk3F8H7dT7LKOa6XrxvZTZrADSRc30+Z26zPN
64 e9zTaf42Gvt0/l0Zs1BHwbaOXqO+XuwJ3/F9Sf3PQYWXD3EOWjpHDP/X/1vAs6lV
65 SLkm6J/9KKE1m6I6LTYjIXuYt4SXybW6N2TSy54hhQtYcDUnIU2hR/PHVWKrGA0J
66 kELgrtTNTdbML27O5gFWU4PLUEYTZ9fN11D6qUZKxLcPOiPPHXkiILMRCCnG5DYI
67 ksBAU/YlAoGBAPxZO9VO18TYc8THV1nLKcvT2+1oSs1UcA2wNQMU55t910ZYinRa
68 MRwUhMOf8Mv5wOeiZaRICQB1PnVWtDVmGECgPpK6jUxqAwn8rgJcnoafLGL5YKMY
69 RVafTe6N5LXgCaOcJrk21wxs6v7ninEbUxxc575urOvZMBkymDw91dwbAoGBAPwa
70 YRhKhrzFKZzdK0RadVjnxKvolUllpoqqg3XuvmeAJHAOAnaOgVWq68NAcp5FZJv0
71 2D2Up7TX8pjf9MofP1SJbcraKBpK4NzfNkA0dSdEi+FhVofAJ9umB2o5LW1n7sab
72 UIrjsdzSJK/9Zb9yTTHPyibYzNEgaJV1HsbxfEFXAoGAYO2RmvRm0phll18OQVJV
73 IpKk9kLKAKZ/R/K32hAsikBC8SVPQTPniyaifFWx81diblalff2hX4ipTf7Yx24I
74 wMIMZuW7Im/R7QMef4+94G3Bad7p7JuE/qnAEHJ2OBnu+eYfxaK35XDsrq6XMazS
75 NqHE7hOq3giVfgg+C12hCKMCgYEAtu9dbYcG5owbehxzfRI2/OCRsjz/t1bv1seM
76 xVMND4XI6xb/apBWAZgZpIFrqrWoIBM3ptfsKipZe91ngBPUnL9s0Dolx452RVAj
77 yctHB8uRxWYgqDkjsxtzXf1HnZBBkBS8CUzYj+hdfuddoeKLaY3invXLCiV+PpXS
78 U4KAK9kCgYEAtSv0m5+Fg74BbAiFB6kCh11FYkW94YI6B/E2D/uVTD5dJhyEUFgZ
79 cWsudXjMki8734WSpMBqBp/J8wG3C9ZS6IpQD+U7UXA+roB7Qr+j4TqtWfM+87Rh
80 maOpG56uAyR0w5Z9BhwzA3VakibVk9KwDgZ29WtKFzuATLFnOtCS46E=
81 -----END RSA PRIVATE KEY-----
82 EOF
83 chmod 600 ${VIRL_PKEY}
84
85 #
86 # Pick a random host from the array of VIRL servers, and attempt
87 # to reach it and verify it's status.
88 #
89 # The server must be reachable, and have a "status" file with
90 # the content "PRODUCTION", to be selected.
91 #
92 # If the server is not reachable, or does not have the correct
93 # status, remove it from the array and start again.
94 #
95 # Abort if there are no more servers left in the array.
96 #
97 while [[ ! "$VIRL_SERVER" ]]
98 do
99     num_hosts=${#VIRL_SERVERS[@]}
100     if [ $num_hosts == 0 ]
101     then
102         echo "No more VIRL candidate hosts available, failing."
103         exit 127
104     fi
105     element=$[ $RANDOM % $num_hosts ]
106     virl_server_candidate=${VIRL_SERVERS[$element]}
107     virl_server_status=$(ssh ${SSH_OPTIONS} ${VIRL_USERNAME}@${virl_server_candidate} cat $VIRL_SERVER_STATUS_FILE 2>&1)
108     echo VIRL HOST $virl_server_candidate status is \"$virl_server_status\"
109     if [ "$virl_server_status" == "$VIRL_SERVER_EXPECTED_STATUS" ]
110     then
111         # Candidate is in good status. Select this server.
112         VIRL_SERVER="$virl_server_candidate"
113     else
114         # Candidate is in bad status. Remove from array.
115         VIRL_SERVERS=("${VIRL_SERVERS[@]:0:$element}" "${VIRL_SERVERS[@]:$[$element+1]}")
116     fi
117 done
118
119 SCRIPT_DIR="$( cd "$( dirname "${BASH_SOURCE[0]}" )" && pwd )"
120
121 # Download VPP and HC packages from the current branch
122 echo Downloading packages...
123 bash ${SCRIPT_DIR}/resources/tools/scripts/download_hc_pkgs.sh ${STREAM} ${OS}
124
125 if [ "${OS}" == "centos7" ]; then
126     VPP_PKGS=(*.rpm)
127 else
128     VPP_PKGS=(*.deb)
129 fi
130 echo ${VPP_PKGS[@]}
131 VIRL_DIR_LOC="/tmp"
132 VPP_PKGS_FULL=(${VPP_PKGS[@]})
133
134 # Prepend directory location at remote host to package file list
135 for index in "${!VPP_PKGS_FULL[@]}"; do
136     VPP_PKGS_FULL[${index}]=${VIRL_DIR_LOC}/${VPP_PKGS_FULL[${index}]}
137 done
138
139 echo "Updated file names: " ${VPP_PKGS_FULL[@]}
140
141 cat ${VIRL_PKEY}
142
143 # Copy the files to VIRL hosts
144 DONE=""
145 for index in "${!VIRL_SERVER[@]}"; do
146     # Do not copy files in case they have already been copied to the VIRL host
147     [[ "${DONE[@]}" =~ "${VIRL_SERVER[${index}]}" ]] && copy=0 || copy=1
148
149     if [ "${copy}" -eq "0" ]; then
150         echo "files have already been copied to the VIRL host ${VIRL_SERVER[${index}]}"
151     else
152         if [ "${OS}" == "centos7" ]; then
153             scp ${SSH_OPTIONS} *.rpm \
154                 ${VIRL_USERNAME}@${VIRL_SERVER[${index}]}:${VIRL_DIR_LOC}/
155         else
156             scp ${SSH_OPTIONS} *.deb \
157                 ${VIRL_USERNAME}@${VIRL_SERVER[${index}]}:${VIRL_DIR_LOC}/
158         fi
159          result=$?
160         if [ "${result}" -ne "0" ]; then
161             echo "Failed to copy files to VIRL host ${VIRL_SERVER[${index}]}"
162             echo ${result}
163             exit ${result}
164         else
165             echo "files successfully copied to the VIRL host ${VIRL_SERVER[${index}]}"
166         fi
167         DONE+=(${VIRL_SERVER[${index}]})
168     fi
169 done
170
171 # Start a simulation on VIRL server
172 echo "Starting simulation on VIRL server"
173
174 function stop_virl_simulation {
175     ssh ${SSH_OPTIONS} ${VIRL_USERNAME}@${VIRL_SERVER}\
176         "stop-testcase ${VIRL_SID}"
177 }
178
179 VIRL_SID=$(ssh ${SSH_OPTIONS} \
180     ${VIRL_USERNAME}@${VIRL_SERVER} \
181     "start-testcase -c ${VIRL_TOPOLOGY} -r ${VIRL_RELEASE} ${VPP_PKGS_FULL[@]}")
182 retval=$?
183 if [ "${retval}" -ne "0" ]; then
184     echo "VIRL simulation start failed"
185     exit ${retval}
186 fi
187
188 if [[ ! "${VIRL_SID}" =~ session-[a-zA-Z0-9_]{6} ]]; then
189     echo "No VIRL session ID reported."
190     exit 127
191 fi
192
193 # Upon script exit, cleanup the simulation execution
194 trap stop_virl_simulation EXIT
195 echo ${VIRL_SID}
196
197 ssh_do ${VIRL_USERNAME}@${VIRL_SERVER} cat /scratch/${VIRL_SID}/topology.yaml
198
199 # Download the topology file from virl session
200 scp ${SSH_OPTIONS} \
201     ${VIRL_USERNAME}@${VIRL_SERVER}:/scratch/${VIRL_SID}/topology.yaml \
202     topologies/enabled/topology.yaml
203
204 retval=$?
205 if [ "${retval}" -ne "0" ]; then
206     echo "Failed to copy topology file from VIRL simulation"
207     exit ${retval}
208 fi
209
210 virtualenv --system-site-packages env
211 . env/bin/activate
212
213 echo pip install
214 pip install -r ${SCRIPT_DIR}/requirements.txt
215
216 pykwalify -s ${SCRIPT_DIR}/resources/topology_schemas/3_node_topology.sch.yaml \
217           -s ${SCRIPT_DIR}/resources/topology_schemas/topology.sch.yaml \
218           -d ${SCRIPT_DIR}/topologies/enabled/topology.yaml \
219           -vvv
220
221 if [ "$?" -ne "0" ]; then
222     echo "Topology schema validation failed."
223     echo "However, the tests will start."
224 fi
225
226 PYTHONPATH=`pwd` pybot -L TRACE -W 136\
227     -v TOPOLOGY_PATH:${SCRIPT_DIR}/topologies/enabled/topology.yaml \
228     --suite "tests.vpp.func" \
229     --include HC_FUNC \
230     --noncritical EXPECTED_FAILING \
231     tests/
232
233 RETURN_STATUS=$?
234
235 # Get Honeycomb log file from virl host
236 scp ${SSH_OPTIONS} \
237     ${VIRL_USERNAME}@${VIRL_SERVER}:/scratch/${VIRL_SID}/honeycomb.log . || true
238
239 # Archive artifacts
240 mkdir archive
241 for i in ${ARCHIVE_ARTIFACTS[@]}; do
242     cp $( readlink -f ${i} | tr '\n' ' ' ) archive/
243 done
244
245 exit ${RETURN_STATUS}

©2016 FD.io a Linux Foundation Collaborative Project. All Rights Reserved.
Linux Foundation is a registered trademark of The Linux Foundation. Linux is a registered trademark of Linus Torvalds.
Please see our privacy policy and terms of use.